#ifndef D6L
#define D6L
#include "WTL.H"

#define D6R_0            0.3326705529500825764
#define D6R_1            0.8068915093110925474
#define D6R_2            0.4598775021184914324
#define D6R_3            0.1350110200102546676
#define D6R_4            0.08544127388202667206
#define D6R_5            0.03522629188570953335
//======================================================================
// D6
// 
scomplex U_D6(integer k){
    TRIG_VVARS
    S.Mas[0]=SET_ELEM( D6R_0,0);
    S.Mas[1]=SET_ELEM( D6R_1,0);
    S.Mas[2]=SET_ELEM( D6R_2,0);
    S.Mas[3]=SET_ELEM(-D6R_3,0);
    S.Mas[4]=SET_ELEM(-D6R_4,0);
    S.Mas[5]=SET_ELEM( D6R_5,0);
    for(i=6;i<k;i++) S.Mas[i]=SET_ELEM(0,0);
    return S;
};
//======================================================================
// 
scomplex V_D6(integer k){
    TRIG_VVARS
    S.Mas[0]=SET_ELEM(  -D6R_1,0);
    S.Mas[1]=SET_ELEM(   D6R_0,0);
    S.Mas[k-4]=SET_ELEM(-D6R_5,0);
    S.Mas[k-3]=SET_ELEM(-D6R_4,0);
    S.Mas[k-2]=SET_ELEM( D6R_3,0);
    S.Mas[k-1]=SET_ELEM( D6R_2,0);
    for(i=2;i<k-4;i++) S.Mas[i]=SET_ELEM(0,0);
    return S;
};
//======================================================================
//  D6:
scomplex* Filtrs_D6(integer k,integer p) {
    TRIG_FVARS
    WORK(D6)
    FREE_MEMORY
    return Filtr;
}
//======================================================================
//         
integer D6_MAX_ITER(integer k) {
    integer p=0;
    real d=k;
    while(1) {
		d/=2;
		if(d==(integer)d) p++;
		else break;
	}
    if(p) return p-3;
    return p;
};
#endif
